/*
 * Created on 11 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.bull.eclipse.jonas;

import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jdt.core.Flags;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.IPackageFragment;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.core.ToolFactory;
import org.eclipse.jdt.core.formatter.CodeFormatter;
import org.eclipse.jface.dialogs.ProgressMonitorDialog;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.ListSelectionDialog;

import com.bull.eclipse.jonas.utils.UtilServicesClass;

/**
 */
public class EjbGenInterfaces {
	private ICompilationUnit cu;
	private String[] szMethode_ =
		{
			"ejbCreate",
			"ejbPostCreate",
			"ejbRemove",
			"ejbLoad",
			"ejbStore",
			"ejbActivate",
			"ejbPassivate",
			"ejbPassivate",
			"setEntityContext",
			"unsetEntityContext",
			"setSessionContext",
			"unsetSessionContext",
			"afterBegin",
			"afterCompletion",
			"beforeCompletion",
			"ejbFind" };

	public void run(ICompilationUnit cu) throws Exception {
		// gen remote
		this.cu = cu;

		// mettre  jour le BeanLocal
		final String s = cu.getElementName().replaceAll("EJB.java", "");
		final String sEJB = cu.getElementName().replaceAll(".java", "");

		// Refresh
		IPackageFragment pkg = (IPackageFragment) cu.getParent();
		String jonasprojName = cu.getParent().getJavaProject().getElementName();

		// get the corresponding JonasProject object
		final IProject proj =
			ResourcesPlugin.getWorkspace().getRoot().getProject(jonasprojName);

		UtilServicesClass.saveFiles();
		
		final IMethod[] sel = getMethodes(sEJB);
		if (sel == null)
			return;

		/***
		 * Create worker thread
		 */

		IRunnableWithProgress worker = new IRunnableWithProgress() {
			public void run(IProgressMonitor monitor)
				throws InvocationTargetException {
				try {

					monitor.setTaskName(
						JonasPluginResources.GEN_INTERFACES_TITLE);

					// local/remote
					monitor.beginTask(
						JonasPluginResources.GEN_INTERFACES_MSG_LOCAL,
						5);
					updEjbLocalFile(s + "Local", sel);
					monitor.worked(1);

					monitor.setTaskName(
						JonasPluginResources.GEN_INTERFACES_MSG_REMOTE);
					updEjbLocalFile(s, sel);
					monitor.worked(2);

					// createn interface home/localHome
					monitor.setTaskName(
						JonasPluginResources.GEN_INTERFACES_MSG_HOME);
					updEjbHomeFile(s + "Home");
					monitor.worked(3);

					monitor.setTaskName(
						JonasPluginResources.GEN_INTERFACES_MSG_LOCALH);
					updEjbHomeFile(s + "LocalHome");
					monitor.worked(4);

					monitor.setTaskName(
						JonasPluginResources.GEN_INTERFACES_MSG_LOCALH);
					updEjbBeanFile(sEJB);
					monitor.worked(5);

				} catch (Exception e) {
					System.out.println("Excepion : " + e.getMessage());
				} finally {
					monitor.done();
				}
			}
		};

		/***
		 * Run worker thread
		 */
		try {
			new ProgressMonitorDialog(
				PlatformUI
					.getWorkbench()
					.getActiveWorkbenchWindow()
					.getShell())
					.run(
				false,
				false,
				worker);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}

	}

	private void updEjbBeanFile(String sUnit) throws Exception {
		boolean bFound = false;

		IPackageFragment pkg = (IPackageFragment) cu.getParent();
		//
		ICompilationUnit unitA = null;
		try {
			unitA = pkg.getCompilationUnit(sUnit + ".java");
			if (!unitA.getResource().exists())
				return;

		} catch (Exception ex) {
			// return if unknown ..
			return;
		}

		IType itCible = unitA.getType(sUnit);
		// delete all ejbPostCreate methods
		IMethod[] ime = itCible.getMethods();

		int iCount = 0;
		for (int j = 0; j < ime.length; j++) {
			if (ime[j].getElementName().equals("ejbPostCreate"))
				iCount++;
		}
		
		int crCount = 0;
		for (int j = 0; j < ime.length; j++) {
			if (ime[j].getElementName().equals("ejbCreate"))
				crCount++;
		}

		//
		// si pas de mthode ejbPostCreate --> les crer
		//
		if (iCount == 0) {
			//			for each ejbCreate Method, create an ejbPostCreate method
			for (int j = 0; j < ime.length; j++) {
				if (ime[j].getElementName().equals("ejbCreate")) {
					// ime[j].delete(true, null);
					itCible.createMethod(
						MakeEJBPostCreateMethode(ime[j]),
						null,
						true,
						null);

				}
			}
		}

//		// for each ejbCreate Method, create an ejbPostCreate method
//		for (int j = 0; j < ime.length; j++) {
//			if (ime[j].getElementName().equals("ejbCreate")) {
//				
//				// ime[j].delete(true, null);
//				itCible.createMethod(
//					MakeEJBPostCreateMethode(ime[j]),
//					null,
//					true,
//					null);
//
//			}
//		}

		// reformat code ..
		CodeFormat(unitA);

	}

	private void updEjbLocalFile(String sUnit, IMethod[] imeSelected)
		throws Exception {

		boolean bFound = false;

		IPackageFragment pkg = (IPackageFragment) cu.getParent();
		//
		ICompilationUnit unitA = null;
		try {
			unitA = pkg.getCompilationUnit(sUnit + ".java");
			if (!unitA.getResource().exists())
				return;

		} catch (Exception ex) {
			// return if unknown ..
			return;
		}

		IType itCible = unitA.getType(sUnit);

		// supprimer mthodes dj inscrites
		IMethod[] ime = itCible.getMethods();
		for (int j = 0; j < ime.length; j++) {
			ime[j].delete(true, null);
		}

		System.out.println("Liste des mthodes publiques");
		IType[] it = cu.getAllTypes();

		//			for (int i = 0; i < it.length; i++) {
		//			ime = it[i].getMethods();
		//
		//			for (int j = 0; j < ime.length; j++) {

		//				// mthode publique ?
		//				if (ime[j].getFlags() != Flags.AccPublic)
		//					continue;
		//
		//				// mthode abstraite ?
		//				if (ime[j].getFlags() == Flags.AccAbstract)
		//					continue;
		//
		//				// mthode EJBxxx ?
		//				if (MethodeToIgnore(ime[j].getElementName()))
		//					continue;

		// Ne retenir que les mthodes qui sont slectionnes
		//if ()
		for (int i = 0; i < imeSelected.length; i++) {
			System.out.println(
				"liste des methodes retenues : "
					+ imeSelected[i].getElementName());
		}

		for (int i = 0; i < imeSelected.length; i++) {
			//	if (ime[j].getElementName().equals(imeSelected[u].getElementName())) {
			// ajouter thode ...
			String s = MakeMethode(imeSelected[i], false, sUnit);
			System.out.println("ajout meth : " + s);
			itCible.createMethod(s, null, true, null);

			//	}
		}
		//			}
		//		}
		CodeFormat(unitA);
	}

	private void updEjbHomeFile(String sUnit) throws Exception {

		IPackageFragment pkg = (IPackageFragment) cu.getParent();

		//
		ICompilationUnit unitA = null;
		try {
			unitA = pkg.getCompilationUnit(sUnit + ".java");
			if (!unitA.getResource().exists())
				return;

		} catch (Exception ex) {
			// return if unknown ..
			return;
		}

		IType itCible = unitA.getType(sUnit);

		// supprimer mthodes dj inscrites
		IMethod[] ime = itCible.getMethods();
		for (int j = 0; j < ime.length; j++) {
			if (ime[j].getElementName().startsWith("Find"))
				continue;
			if (ime[j].getElementName().startsWith("create"))
				ime[j].delete(true, null);
		}

		System.out.println("Liste des mthodes publiques");
		IType[] it = cu.getAllTypes();
		for (int i = 0; i < it.length; i++) {
			ime = it[i].getMethods();

			for (int j = 0; j < ime.length; j++) {

				// mthode publique ?
				if (ime[j].getFlags() != Flags.AccPublic)
					continue;

				// mthode abstraite ?
				if (ime[j].getFlags() == Flags.AccAbstract)
					continue;

				String szMethode = ime[j].getElementName();

				//if (!szMethode.startsWith("ejb"))
				//	continue;

				if (!szMethode.startsWith("ejbCreate"))
					continue;

				// ajouter thode ...
				String s = MakeMethode(ime[j], true, sUnit);
				System.out.println("ajout meth : " + s);
				itCible.createMethod(s, null, true, null);

			}
		}
		// reformat code
		CodeFormat(unitA);
	}

	private String MakeMethode(IMethod ime, boolean bHome, String EJBName)
		throws Exception {

		StringBuffer sb = new StringBuffer("public ");
		String sig = ime.getReturnType();
		// force method = 'EJBname' + 'Local'
		if (bHome)
			sig = EJBName.replaceAll("Home", "");

		String sName = ime.getElementName();

		if (sName.startsWith("ejbCreate"))
			sName = "create";
		else if (sName.startsWith("ejbFind"))
			sName = sName.replaceAll("ejbFind", "Find");

		sb.append(getType(sig) + " ");
		sb.append(sName + "(");
		String[] spars = ime.getParameterNames();
		String[] sparstype = ime.getParameterTypes();
		for (int k = 0; k < ime.getNumberOfParameters(); k++) {
			if (k != 0)
				sb.append(", ");
			sb.append(getType(sparstype[k]));
			sb.append(" ");
			sb.append(spars[k]);
		}
		sb.append(")");
		//
		// Build excpetion depending on the type of interface
		//
		HashMap hMap = new HashMap(10);
		String[] exc = ime.getExceptionTypes();

		for (int u = 0; u < exc.length; u++) {
			String s = getType(exc[u]);
			hMap.put(s, s);
		}
		String szRemote = "java.rmi.RemoteException";
		String szRemote_ = "RemoteException";

		// If local object and remoteExceptio is present then remove it
		if (EJBName.indexOf("Local") != -1 && hMap.get(szRemote) != null)
			hMap.remove(szRemote);

		if (EJBName.indexOf("Local") != -1 && hMap.get(szRemote_) != null)
			hMap.remove(szRemote_);

		// If not local object and not remoteException is present then add it
		if (EJBName.indexOf("Local") == -1) {
			if ((hMap.get(szRemote) == null) && (hMap.get(szRemote_) == null))
				hMap.put(szRemote, szRemote);
		}
		// 
		if (hMap.size() != 0) {
			sb.append(" throws ");
			Iterator it = hMap.values().iterator();
			while (it.hasNext()) {
				sb.append((String) it.next());
				if (it.hasNext())
					sb.append(", ");
			}
		}

		sb.append(";\n\n");

		return sb.toString();
	}

	private String MakeEJBPostCreateMethode(IMethod ime) throws Exception {

		StringBuffer sb = new StringBuffer("public void ejbPostCreate (");
		String[] spars = ime.getParameterNames();
		String[] sparstype = ime.getParameterTypes();
		for (int k = 0; k < ime.getNumberOfParameters(); k++) {
			if (k != 0)
				sb.append(", ");
			sb.append(getType(sparstype[k]));
			sb.append(" ");
			sb.append(spars[k]);
		}
		String[] exc = ime.getExceptionTypes();
		sb.append(")");
		if (exc.length != 0) {
			sb.append(" throws ");
			for (int u = 0; u < exc.length; u++) {
				if (u != 0)
					sb.append(", ");
				sb.append(getType(exc[u]));
			}
		}

		sb.append(" {}\n\n");
		return sb.toString();

	}

	private void CodeFormat(ICompilationUnit unit) throws Exception {
		// reformat code
		CodeFormatter ic = ToolFactory.createCodeFormatter(JavaCore.getOptions());
		String srcCode = unit.getBuffer().getContents();
		System.out.println("in : " + srcCode);
		srcCode = ic.format(CodeFormatter.K_COMPILATION_UNIT, srcCode,4 ,4 ,0 , null).toString();
		System.out.println("out : " + srcCode);
		unit.getBuffer().setContents(srcCode);
		unit.getBuffer().save(null, false);
	}

	private boolean MethodeToIgnore(String szMethode) {
		for (int m_ = 0; m_ < szMethode_.length; m_++) {
			if (szMethode.equalsIgnoreCase(szMethode_[m_]))
				return true;
			if (szMethode.startsWith("ejbFind"))
				return true;

		}
		return false;
	}

	private String getType(String s) {

		if (s.equalsIgnoreCase("v"))
			return "void";

		if (s.equalsIgnoreCase("b"))
			return "byte";
		if (s.equalsIgnoreCase("[b"))
			return "byte []";

		if (s.equalsIgnoreCase("c"))
			return "char";
		if (s.equalsIgnoreCase("[c"))
			return "char []";

		if (s.equalsIgnoreCase("d"))
			return "double";
		if (s.equalsIgnoreCase("[d"))
			return "double []";

		if (s.equalsIgnoreCase("f"))
			return "float";
		if (s.equalsIgnoreCase("[f"))
			return "float []";

		if (s.equalsIgnoreCase("i"))
			return "int";
		if (s.equalsIgnoreCase("[i"))
			return "int []";

		if (s.equalsIgnoreCase("j"))
			return "long";
		if (s.equalsIgnoreCase("[j"))
			return "long []";

		if (s.equalsIgnoreCase("s"))
			return "short";
		if (s.equalsIgnoreCase("[s"))
			return "short []";

		if (s.equalsIgnoreCase("z"))
			return "boolean";
		if (s.equalsIgnoreCase("[z"))
			return "boolean []";

		if (s.startsWith("Q")) {
			return s.substring(1, s.length() - 1);
		}

		if (s.startsWith("[Q")) {
			return s.substring(2, s.length() - 1) + " []";
		}

		return s;

	}


	//
	// get Methods to pace on the remote interface
	// ask user to select then  
	private IMethod[] getMethodes(String sUnit) throws Exception {

		IWorkbenchWindow[] wk = PlatformUI.getWorkbench().getWorkbenchWindows();
		IPackageFragment pkg = (IPackageFragment) cu.getParent();
		//
		ICompilationUnit unitA = null;
		try {
			unitA = pkg.getCompilationUnit(sUnit + ".java");
			if (!unitA.getResource().exists())
				return null;

		} catch (Exception ex) {
			// return if unknown ..
			System.out.println("Exception : " + ex.getMessage());
			return null;
		}

		IType itCible = unitA.getType(sUnit);
		// delete all ejbPostCreate methods
		IMethod[] ime = itCible.getMethods();
		Vector vmetfull = new Vector(10);
		Vector vmet = new Vector(10);

		//
		// get methods candidate to go to the remote/local interface
		// must be public
		// and # ejbXXX
		//		  
		for (int i = 0; i < ime.length; i++) {
			System.out.println(" method : " + ime[i].getElementName());

			// mthode publique ?
			if ((ime[i].getFlags() & Flags.AccPublic) == 0)
				continue;
			// mthode abstraite ?	
			if ((ime[i].getFlags() & Flags.AccAbstract) != 0)
				continue;

			// mthode EJBxxx ?
			if (MethodeToIgnore(ime[i].getElementName()))
				continue;
			System.out.println(
				" candidate method : " + ime[i].getElementName());

			String szSign = MakeMethode(ime[i], false, "");

			vmet.add(new myMeth(szSign, i));
			vmetfull.add(szSign);
		}

		// any method candidate ?
		if (vmet.size() == 0)
			return null;

		final String[] szMethfull = (String[]) vmetfull.toArray(new String[0]);
		//final String[] szMeth = (String[]) vmet.toArray(new String[0]);

		ListSelectionDialog dlg =
			new ListSelectionDialog(
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
				new Object(),
				new IStructuredContentProvider() {

			public void dispose() {
			}

			public Object[] getElements(Object inputElement) {

				return szMethfull;
			}

			public void inputChanged(Viewer viewer1, Object obj, Object obj1) {
				int i = 0;
			}

		}, new LabelProvider(), "Select methods from BEAN");

		dlg.setTitle("Preselect Methods for Remote/Local Interfaces");
		dlg.open();

		final Object[] results_upd = (Object[]) dlg.getResult();
		int ret = dlg.getReturnCode();
		// return null ( list of methods) , if user press cancel or nothing is selected 
		if (ret == 1)
			return null;
		if (results_upd == null)
			return null;
		if (results_upd.length == 0)
			return null;

		Vector imeRet = new Vector(10);

		for (int i = 0; i < results_upd.length; i++) {
			for (int v = 0; v < vmet.size(); v++) {

				myMeth my = (myMeth) vmet.get(v);
				if (!results_upd[i].equals(my.getMethode()))
					continue;

				imeRet.add(ime[my.getOrder()]);
				break;
			}
		}

		return (IMethod[]) imeRet.toArray(new IMethod[0]);

	}

	// private class to stock all methods	
	class myMeth {
		private String szSign = null;
		private int iOrder = 0;
		myMeth(String szSign, int iOrder) {
			this.szSign = szSign;
			this.iOrder = iOrder;
		}
		public int getOrder() {
			return this.iOrder;
		}
		public String getMethode() {
			return this.szSign;
		}
	}
}
