package com.bull.eclipse.jonas.actions;

/*
 * (c) Copyright Bull SA 2003.
 * All Rights Reserved.
 */
import java.io.BufferedWriter;
import java.io.FileWriter;

import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationType;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.core.ILaunchManager;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.ui.externaltools.internal.model.IExternalToolConstants;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasPluginResources;
import com.bull.eclipse.jonas.utils.StringUtil;
import com.bull.eclipse.jonas.utils.TemplateDirUtil;

public class StartActionDelegate implements IWorkbenchWindowActionDelegate {

			
	private IWorkbenchWindow window;
	private IAction action;
	private static final String JONAS_LAUNCH_BAT = "/jonas_launch_DOS.bat";

	/*
	 * @see IWorkbenchWindowActionDelegate#dispose()
	 */
	public void dispose() {
	}

	/*
	 * @see IWorkbenchWindowActionDelegate#init(IWorkbenchWindow)
	 */
	public void init(IWorkbenchWindow window) {
		this.window = window;
	}

	/*
	 * @see IActionDelegate#run(IAction)
	 */
	public void run(IAction action) {	
		JonasLauncherPlugin.log(JonasLauncherPlugin.getResourceString("msg.start"));
		JonasLauncherPlugin.log("msg.start");
		try {	
			if (JonasLauncherPlugin.getDefault().isDebugMode()) {
				JonasLauncherPlugin.getDefault().getJonasBootstrap().start();
			} else {
				String pathJonas = JonasLauncherPlugin.getDefault().getJonasDir();;
				String batchfilePath = TemplateDirUtil.getTemplateDir() + JONAS_LAUNCH_BAT; 
				String param = JonasLauncherPlugin.getDefault().getJonasBootstrap().getStartCommand();
				this.action = action;
				ILaunchManager manager = DebugPlugin.getDefault().getLaunchManager();
				ILaunchConfigurationType configType = manager.getLaunchConfigurationType(IExternalToolConstants.ID_PROGRAM_BUILDER_LAUNCH_CONFIGURATION_TYPE);
				ILaunchConfigurationWorkingCopy wc = configType.newInstance(null, JonasLauncherPlugin.getDefault().getJonasBootstrap().getLabel());
				MAJLaunchingBatch(batchfilePath);
				wc.setAttribute(IExternalToolConstants.ATTR_LOCATION, batchfilePath);				
				wc.setAttribute(IExternalToolConstants.ATTR_TOOL_ARGUMENTS,param);
				ILaunchConfiguration config=wc.doSave();
				config.launch(ILaunchManager.RUN_MODE, null);
			}
		} catch (Exception ex) {
			String msg = JonasLauncherPlugin.getResourceString("msg.start.failed");
			JonasLauncherPlugin.log(msg + "/n");
			JonasLauncherPlugin.log(ex);			
		}
	}

	private void MAJLaunchingBatch(String batchFilePath) {
		String param = "start %JAVA_HOME%/bin/java ";
		String vmArgs [] = JonasLauncherPlugin.getDefault().getJonasBootstrap().getVmArgs();
		String prefParams[] = StringUtil.cutString(JonasLauncherPlugin.getDefault().getJvmParamaters(), JonasPluginResources.PREF_PAGE_LIST_SEPARATOR);
		vmArgs = StringUtil.concat(vmArgs, prefParams);
		int i =0;
		String vmArg = "";
		while(i != vmArgs.length ){
			vmArg += vmArgs[i]+" ";
			i++;				
		}
		String classpaths [] =JonasLauncherPlugin.getDefault().getJonasBootstrap().getClasspath();
		int j =0;
		String classpath="\"";
		while(j != classpaths.length ){
			if(j==(classpaths.length-1))
				classpath += classpaths[j]+"\" ";
			else
				classpath += classpaths[j]+";";
			j++;				
		}
		param += vmArg+"-classpath "+classpath+JonasLauncherPlugin.getDefault().getJonasBootstrap().getMainClass()+" %1 %2";
		try{
			BufferedWriter output = new BufferedWriter(new FileWriter(batchFilePath));
			output.write(param);
			output.flush();
			output.close();
		}catch(Exception e){
			System.out.println("File Not Found = "+e.getMessage());
		}
		
	}
	



	/*
	 * @see IActionDelegate#selectionChanged(IAction, ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {

	}

	/**
	 * @return
	 */
	public IAction getAction() {
		return action;
	}

	/**
	 * @param action
	 */
	public void setAction(IAction action) {
		this.action = action;
	}



}

