package com.bull.eclipse.jonas.actions.ear;

import java.util.Enumeration;
import java.util.Vector;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.ListSelectionDialog;

import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasProjectAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.RarManagement;
import com.bull.eclipse.jonas.utils.UpdatePropsFile;
import com.bull.eclipse.newear.NewEarRunner;



public class	ExportEarActionDelegate extends JonasProjectAbstractActionDelegate
{
	static private Object[] oldSelection = null; 
	private JonasProject prj = null;
	
	
	public boolean doActionOn(JonasProject prj) throws Exception {	
		this.prj = prj;
		// Update build.properties with JONAS_ROOT
		UpdatePropsFile.updatePropsProject(prj);
		
		//Build the j2ee module list
		Vector ejbListe = prj.getJarEjbName();
		Vector listModules = new Vector();
		String[] rarListe = RarManagement.searchRarInProject(prj);
		if (ejbListe != null) {
			for (Enumeration e = ejbListe.elements() ; e.hasMoreElements() ;) {
				String ejbName = (String) e.nextElement();
				listModules.add("Ejb Module : " + ejbName);
			}
		} 
		if ((prj.getWebContext() != null) && (!prj.getWebContext().equals(""))) 
			listModules.add("Web module : " + prj.getWebContext());

		if (rarListe != null) {
			for (int i=0;i<rarListe.length;i++) {
				String rarName = rarListe[i];
				listModules.add("Rar Module : " + rarName);
			}
		} 
		
		final String[] listModulesJ2ee = (String[]) listModules.toArray(new String[0]);			
		ListSelectionDialog lsd =
			new ListSelectionDialog(
				PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell(),
				new Object(),
				new IStructuredContentProvider() {

			public void dispose() {
			}

			public Object[] getElements(Object inputElement) {
				return listModulesJ2ee;
			}

			public void inputChanged(Viewer viewer1, Object obj, Object obj1) {
				int i = 0;
			}

		}, new LabelProvider(), "Select modules to put in application");

		lsd.setTitle("Select j2ee modules");
		if (oldSelection == null) {
			lsd.setInitialSelections(listModulesJ2ee);	
		} else {
			lsd.setInitialSelections(oldSelection);
		}
		lsd.open();

		Object[] results_upd = lsd.getResult();
		
		oldSelection = results_upd;
		
		int ret = lsd.getReturnCode();
		// return null ( list of methods) , if user press cancel or nothing is selected 
		if (ret == 1)
			throw new Exception("Operation is cancelled");
		if ((results_upd == null) || (results_upd.length == 0))
			throw new Exception("There is no element to build the application");
		
		Vector moduleEjbSel = new Vector();
		for(int i=0;i<oldSelection.length;i++) {
			if (oldSelection[i].toString().startsWith("Ejb")) {
				moduleEjbSel.add(oldSelection[i].toString().replaceAll("Ejb Module : ",""));
			}
		}

		Vector moduleWebSel = new Vector();
		for(int i=0;i<oldSelection.length;i++) {
			if (oldSelection[i].toString().startsWith("Web")) {
				moduleWebSel.add(oldSelection[i].toString().replaceAll("Web Module : ",""));
			}
		}

		Vector moduleRarSel = new Vector();
		for(int i=0;i<oldSelection.length;i++) {
			if (oldSelection[i].toString().startsWith("Rar")) {
				moduleRarSel.add(oldSelection[i].toString().replaceAll("Rar Module : ",""));
			}
		}
				
		NewEarRunner runner = new NewEarRunner(prj,moduleEjbSel,moduleWebSel,moduleRarSel);
		runner.RunNewear();

		//TODO Deploy
		//DeployEarActionDelegate.deploy(prj.getProject().getName() + ".ear");

		return false;
	}			

}

