package com.bull.eclipse.jonas.actions.ejb;

import java.io.File;

import org.eclipse.jdt.core.IPackageFragment;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasPackageAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.EjbManagement;
import com.bull.eclipse.jonas.utils.UpdatePropsFile;



public class BuildOneEjbActionDelegate extends JonasPackageAbstractActionDelegate
{

	public boolean doActionOn(IPackageFragment pack) throws Exception {
		// Update build.properties with JONAS_ROOT
		JonasProject jp = (JonasProject)pack.getJavaProject().getProject().getNature(JonasLauncherPlugin.NATURE_ID);
		UpdatePropsFile.updatePropsProject(jp);		

		String projDir = jp.getProject().getFullPath().toOSString();		
		String packName = pack.getPath().removeFirstSegments(1).toOSString();
		String buildFile = projDir + File.separator + packName + File.separator + "build.xml";
		AntUtils.runAnt(buildFile);

		// Deploy EJB		
		String packEJB = pack.getPath().removeFirstSegments(2).toOSString();
		String ejbName = EjbManagement.getEjbName(packEJB,(JonasProject)pack.getJavaProject().getProject().getNature(JonasLauncherPlugin.NATURE_ID));
		//TODO DeployEjbActionDelegate.deploy(ejbName + ".jar");

	    return false;
	}			

}

