package com.bull.eclipse.jonas.actions.ejb;

/*
 * (c) Copyright Bull SA 2003.
 * All Rights Reserved.
 */

import java.util.Vector;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jdt.core.IPackageFragment;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasPackageAbstractActionDelegate;

public class DeployEjbActionDelegate extends JonasPackageAbstractActionDelegate {

	public boolean doActionOn(IPackageFragment pack) throws Exception {
		String packName = pack.getPath().removeFirstSegments(2).toOSString();
		JonasLauncherPlugin.log("PackName = " + packName);
		String jarName = null;
		JonasProject prj = JonasProject.create(pack.getJavaProject());
		Vector vec = prj.getPackageProjectFolder();
		for (int i=0;i < vec.size(); i++) {
			JonasLauncherPlugin.log("Element = " + vec.elementAt(i));
			if (vec.elementAt(i).toString().equals(packName)) {
				JonasLauncherPlugin.log("Element = " + vec.elementAt(i));
				jarName = prj.getJarEjbName().elementAt(i).toString();
				continue;					 
			}				
		}
		if (jarName == null)
			throw new Exception("The EJB does not exist");  
			
		deploy(jarName + ".jar");
		return false;
	}			

  	static public void deploy(String jarName) throws CoreException {
		JonasLauncherPlugin.log("ejbFile = " + jarName);
		String[] options = {"-a",jarName};	
		JonasLauncherPlugin.getDefault().getJonasBootstrap().admin(options);			  		
  	}

}

