/*
 * Created on 29 juil. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.bull.eclipse.jonas.actions.ws;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.IPackageFragment;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.actions.JonasPackageAbstractActionDelegate;
import com.bull.eclipse.jonas.utils.AntUtils;
import com.bull.eclipse.jonas.utils.EjbManagement;
import com.bull.eclipse.jonas.utils.TemplateDirUtil;

/**
 * @author riase
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class GenerateWSClientActionDelegate extends JonasPackageAbstractActionDelegate {
	private VelocityEngine vEngine = null;
	private VelocityContext vContext = null;

	
	public boolean doActionOn(IPackageFragment pack) throws Exception {
		// Update build.properties with JONAS_ROOT
		
		JonasProject jp = (JonasProject)pack.getJavaProject().getProject().getNature(JonasLauncherPlugin.NATURE_ID);
		File wsSrcDir = jp.getProject().getLocation().append("webservicessrc").toFile();
		boolean createDir = true;
		if (!wsSrcDir.exists()) {
			createDir = wsSrcDir.mkdir();
			jp.setSrcAsSourceFolder("webservicessrc");
		}
		if (!createDir)
			throw new IOException("Error until creation web services directory");

		String buildPath = pack.getPath().append("build.xml").toOSString();
		
		AntUtils.runAnt(buildPath, "wsdl2java");
		
		generateTestWS(jp, pack.getElementName());
		
		jp.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );			 
			
		return false;
	}
	
	private void generateTestWS(JonasProject jp, String packEjb) {
		vContext = new VelocityContext();

		String pkgName = packEjb + ".ws.client";
		vContext.put("pkgName", pkgName);
		String pkgNameWithSepar = packEjb.replace('.', File.separatorChar);
		JonasLauncherPlugin.log("pkgName " + pkgNameWithSepar);
		String ejbname = EjbManagement.getEjbName(pkgNameWithSepar,jp);
		JonasLauncherPlugin.log("ejbName " + ejbname);
		String beanname = ejbname.substring(0,1).toUpperCase() + ejbname.substring(1);
		JonasLauncherPlugin.log("beanname " + beanname);
		vContext.put("beanname", ejbname);
		vContext.put("beanName", beanname);
		

		// Generates webapps files
		try {
			vEngine = new VelocityEngine();
			vEngine.setProperty(VelocityEngine.VM_LIBRARY, "");
			vEngine.setProperty(VelocityEngine.RESOURCE_LOADER, "file");
			vEngine.setProperty(VelocityEngine.FILE_RESOURCE_LOADER_PATH,
							TemplateDirUtil.getTemplateDir().concat("/ws"));
			try {
				vEngine.init();
			} catch (Exception e) {
				e.printStackTrace();
			}
			String target = jp.getProject().getLocation().append("webservicessrc").append(pkgNameWithSepar).append("ws").append("client").append("TestWS" + beanname + ".java").toOSString();
			JonasLauncherPlugin.log("Path = " + target);
			generate("TestWS.vm", target);            			
			jp.getProject().refreshLocal( IResource.DEPTH_INFINITE, null );
		} catch (Exception e) {        	
			e.printStackTrace();
		}

	}
	
	 private void generate(String templateFileName, String targetFileName)
			throws Exception, IOException, ResourceNotFoundException,
			ParseErrorException, MethodInvocationException {
		FileWriter fileWriter = null;
		fileWriter = new FileWriter(targetFileName);
		vEngine.mergeTemplate(templateFileName, vContext, fileWriter);
		fileWriter.close();
	}

}
