/*
 * Created on 24 juin 2004
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.bull.eclipse.jonas.utils.xml;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import com.bull.eclipse.jonas.JonasLauncherPlugin;
import com.bull.eclipse.jonas.JonasProject;
import com.bull.eclipse.jonas.utils.TemplateDirUtil;

/**
 * @author riase
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class UpdateXmlFile {
	
	public static void updateWebXmlFileWithAxisServlet(File webXmlFile) {
		File xmlFileTemp = new File(TemplateDirUtil.getTemplateDir() + File.separator + "ws" + File.separator + "axis.web.xml");
		try {
			FileInputStream is = new FileInputStream(webXmlFile);
			Document docXmlWeb = XMLUtils.newDocument(is,true);
			
			Document docXmlTemp = XMLUtils.newDocument(new FileInputStream(xmlFileTemp),false);

			// On teste si les servlet Axis sont dj dclars			
			NodeList nlSC = docXmlWeb.getElementsByTagName("servlet-class");
			for(int i = 0;i < nlSC.getLength(); i++) {
				if (nlSC.item(i).getFirstChild().getNodeValue().equals("org.apache.axis.transport.http.AxisServlet") ||
				nlSC.item(i).getFirstChild().getNodeValue().equals("org.apache.axis.transport.http.AdminServlet") ||
				nlSC.item(i).getFirstChild().getNodeValue().equals("org.apache.axis.monitor.SOAPMonitorService")) 
					return;
					
			}

			// Insertion des tags servlets de Axis a partir du fichier axis.web.xml
			// On rcupre la liste des tags servlets
			NodeList nl1 = docXmlTemp.getElementsByTagName("servlet");
			
			Node servletAxisNode = null;

			// On teste les tags pouvant tre prsents dans le web.xml
			// On commence par servlet-mapping et on descend jusqu'a en trouver un
			Node webNode = getNodeInWebFile(docXmlWeb);
				

			for(int i = 0;i < nl1.getLength(); i++) {
				servletAxisNode = docXmlWeb.importNode(nl1.item(i),true);
				if (webNode.getNodeName().equals("web-app"))
					docXmlWeb.getDocumentElement().appendChild(servletAxisNode);
				else	
					docXmlWeb.getDocumentElement().insertBefore(servletAxisNode,webNode);
			}
			
			NodeList nl2 = docXmlTemp.getElementsByTagName("servlet-mapping");
			for(int i = 0;i < nl2.getLength(); i++) {
				servletAxisNode = docXmlWeb.importNode(nl2.item(i),true);
				if (webNode.getNodeName().equals("web-app"))
					docXmlWeb.getDocumentElement().appendChild(servletAxisNode);
				else
					docXmlWeb.getDocumentElement().insertBefore(servletAxisNode,webNode);
			}

			XMLSerializer xManu = XMLSerializer.getInstance(webNode.getOwnerDocument());
			FileOutputStream fo = new FileOutputStream(webXmlFile);
			xManu.serialize(fo);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	

	}

	public static void updateServerConfigXmlFile(String packName, JonasProject jp, String jarName) {
		File serverConfigFile = new File(jp.getWebInfFolder().getLocation().append("server-config.wsdd").toOSString());
		File deployFile = new File(jp.getProject().getLocation().append(jp.getSrcEJBDir() + File.separator + packName + File.separator + "deploy.wsdd").toOSString());
		//File outputServerConfigFile = new File(jp.getWebInfFolder().getLocation().append("server-config.wsdd").toOSString());						
		try {
			Document docXmlSC = XMLUtils.newDocument(new FileInputStream(serverConfigFile),false);
			Document docXmlDeploy = XMLUtils.newDocument(new FileInputStream(deployFile),false);
			
			NodeList nlSC = docXmlSC.getElementsByTagName("service");
			JonasLauncherPlugin.log("service node = " + nlSC.item(0));
			// Insertion du tag service 
			Node nl1 = docXmlDeploy.getElementsByTagName("service").item(0);
			Node scUpdate = null;
			scUpdate = docXmlSC.importNode(nl1,true);
			JonasLauncherPlugin.log("service node = " + nl1);
			boolean serviceExistant = false;
			XMLSerializer xManu = null;
			for(int i = 0;i < nlSC.getLength(); i++) {
				JonasLauncherPlugin.log("Node = " + nlSC.item(i));
				NamedNodeMap nnm = nlSC.item(i).getAttributes();
				String value = nnm.item(0).getNodeValue();
				if (nnm.item(0).getNodeValue().equals(jarName + "EndPoint")) {
					// Cas o le service avait deja t dclar
					JonasLauncherPlugin.log("On passe dans service deja existant");
					Node replaceNode = nlSC.item(i);
					docXmlSC.getDocumentElement().replaceChild(scUpdate,replaceNode);
					xManu = XMLSerializer.getInstance(replaceNode.getOwnerDocument());
					serviceExistant = true;
				}
			}

			if (!serviceExistant) {	
				JonasLauncherPlugin.log("Service non existant");
				Node transportNode = docXmlSC.getElementsByTagName("transport").item(0);
				docXmlSC.getDocumentElement().insertBefore(scUpdate,transportNode);
				xManu = XMLSerializer.getInstance(transportNode.getOwnerDocument());
			}

			FileOutputStream fo = new FileOutputStream(serverConfigFile);
			xManu.serialize(fo);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	

	}


	public static void updateEjbStandardXmlFile(File ejbStanXmlFile, File xmlFile) {		
		try {
			FileInputStream is = new FileInputStream(ejbStanXmlFile);
			Document docXmlEjb = XMLUtils.newDocument(is,true);			
			Document docXmlTemp = XMLUtils.newDocument(new FileInputStream(xmlFile),false);


			

			// Test if session EJB is already declared
			// In this cas we do nothing
			NodeList nlSC = docXmlEjb.getElementsByTagName("ejb-name");
			String ejbSessionName = docXmlTemp.getElementsByTagName("ejb-name").item(0).getFirstChild().getNodeValue();
			for(int i = 0;i < nlSC.getLength(); i++) {				
				String test = nlSC.item(i).getFirstChild().getNodeValue();
				if (nlSC.item(i).getFirstChild().getNodeValue().equals(ejbSessionName))
						return;
					
			}

//			 Insertion des tags ejb, a partir du fichier xmlFile
			Node session = docXmlTemp.getElementsByTagName("session").item(0);
			Node ejbSessionNode = docXmlEjb.getElementsByTagName("entity").item(0);
			Node sessionNode = docXmlEjb.importNode(session,true);
			docXmlEjb.getDocumentElement().getElementsByTagName("enterprise-beans").item(0).insertBefore(sessionNode, ejbSessionNode);

			XMLSerializer xManu = XMLSerializer.getInstance(ejbSessionNode.getOwnerDocument());
			FileOutputStream fo = new FileOutputStream(ejbStanXmlFile);
			xManu.serialize(fo);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	

	}

	
	private static Node getNodeInWebFile(Document webXmlFile) {
		// On teste les tags pouvant tre prsents dans le web.xml
		// On commence par servlet-mapping et on descend jusqu'a en trouver un
		Node webNode = webXmlFile.getElementsByTagName("servlet-mapping").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("session-config").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("mime-mapping").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("welcome-file-list").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("error-page").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("taglib").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("resource-env-ref").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("resource-ref").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("security-constraint").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("login-config").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("security-role").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("env-entry").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("ejb-ref").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("ejb-local-ref").item(0);
		if (webNode == null) 
			webNode = webXmlFile.getElementsByTagName("web-app").item(0);
		
		return webNode;
	}


}
