/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or 1any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer: Philippe Coq
 * --------------------------------------------------------------------------
 * $Id: AppClientSchemas.java,v 1.1 2003/10/29 10:10:27 coqp Exp $
 * --------------------------------------------------------------------------
 */

package com.bull.eclipse.jonas.utils.xml.desc;


/**
 * This class defines the declarations of Schemas for application-client.xml and jonas-client.xml
 * @author Philippe Coq
 */
public class AppClientSchemas extends CommonsSchemas {

    /**
     * List of schemas used for application-client.xml
     */
    private static final String[] APPCLIENT_SCHEMAS = new String[] {
        "application-client_1_4.xsd"
    };


    /**
     * Build a new object for Schemas handling
     */
    public AppClientSchemas() {
        super();
        addSchemas(APPCLIENT_SCHEMAS);
    }

}
