/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or 1any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer: Florent BENOIT
 * --------------------------------------------------------------------------
 * $Id: WebAppSchemas.java,v 1.1 2003/10/27 14:21:57 benoitf Exp $
 * --------------------------------------------------------------------------
 */

package com.bull.eclipse.jonas.utils.xml.desc;


/**
 * This class defines the declarations of Schemas for web.xml and jonas-web.xml
 * @author Florent Benoit
 */
public class WebAppSchemas extends CommonsSchemas {

    /**
     * List of schemas used for web.xml
     */
    private static final String[] WEBAPP_SCHEMAS = new String[] {
        "schema/web-app_2_4.xsd",
        "schema/jsp_2_0.xsd"
    };


    /**
     * Build a new object for Schemas handling
     */
    public WebAppSchemas() {
        super();
        addSchemas(WEBAPP_SCHEMAS);
    }

}
