/*
 * Created on 14 fvr. 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.bull.eclipse.jonas.wizard;

import java.util.Arrays;

import org.eclipse.core.runtime.Status;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.jdom.DOMFactory;
import org.eclipse.jdt.core.jdom.IDOMCompilationUnit;
import org.eclipse.jdt.core.jdom.IDOMMethod;
import org.eclipse.jdt.core.jdom.IDOMType;
import org.eclipse.jdt.internal.ui.JavaPlugin;
import org.eclipse.jdt.internal.ui.JavaPluginImages;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;

import com.bull.eclipse.jonas.JonasLauncherPlugin;


// Referenced classes of package com.objectlearn.jdt.j2ee.ui.wizards:
//			  CreateEJBBusinessMethodsPage, XDocletTemplates

public class AddEjbMethodWizard extends Wizard
	implements INewWizard
{
 
	public AddEjbMethodWizard()
	{
		
		setDefaultPageImageDescriptor(JavaPluginImages.DESC_WIZBAN_NEWMETH);
		setDialogSettings(JavaPlugin.getDefault().getDialogSettings());
		setWindowTitle("Create a new EJB Method");
	}

	public boolean performFinish()
	{
		if(!methodPage.isPageValid())
		{
			org.eclipse.core.runtime.IStatus status = new Status(4, "AddEjbMethodWizard", 4, "Invalid Type", new Exception());
			methodPage.setStatus(status);
			return false;
		}
		if(theClass != null)
			try
			{
				DOMFactory jdom = new DOMFactory();
				IDOMMethod theMethod = jdom.createMethod(methodPage.getMethodName() + "{}");
				if(theMethod == null)
				{
					org.eclipse.core.runtime.IStatus status = new Status(4, JonasLauncherPlugin.getPluginId(), 4, "Invalid Type", new Exception());
					methodPage.setStatus(status);
					return false;
				}
				int ii = 0;
				String returnType = theMethod.getReturnType();
				if(returnType == null)
				{
					org.eclipse.core.runtime.IStatus status = new Status(4, JonasLauncherPlugin.getPluginId(), 4, "Invalid return type", new Exception());
					methodPage.setStatus(status);
					return false;
				}
				if(theMethod.getParameterTypes() != null)
				{
					for(int i = 0; i < theMethod.getParameterTypes().length; i++)
					{
						String array_element = theMethod.getParameterTypes()[i];
						if(array_element == null)
						{
							org.eclipse.core.runtime.IStatus status = new Status(4, JonasLauncherPlugin.getPluginId(), 4, "Invalid parameter type", new Exception());
							methodPage.setStatus(status);
							return false;
						}
					}

				}
				theMethod.setBody(generateBody(returnType));
//				theMethod.setComment(generateComment(methodPage.getMethodType(), methodPage.getInterfaceType()));
				theType.addChild(theMethod);
				String newContents = theCompUnit.getContents();
				theClass.getCompilationUnit().getBuffer().setContents(newContents);
				theClass.getCompilationUnit().save(null, true);
			}
			catch(Exception e)
			{
				JonasLauncherPlugin.log(e);
			}
		return true;
	}

	private String generateComment(String type, String viewType)
	{
	//	String commentContent = XDocletTemplates.getStringReplacingParameter("xdocletTag@ejb_method", "type", type);
	//	commentContent = XDocletTemplates.setParameterValue(commentContent, "viewType", viewType);
	//	return commentContent;
		return "";
	}

	private String generateBody(String returnType)
	{
		String body = null;
		
		if(Arrays.binarySearch(integerTypes, returnType) >= 0)
			body = "{ \n return 0; \n}\n";
		else
		if(Arrays.binarySearch(doubleTypes, returnType) >= 0)
			body = "{ \n return 0.0; \n}\n";
		else
		if("boolean".equals(returnType))
			body = "{ \n return false;\n}\n";
		else
		if("void".equals(returnType))
			body = "{ \n}\n";
		else
			body = "{ \n return null; \n}\n";
		return body;
	}

	public void addPages()
	{
		super.addPages();
		
		org.eclipse.core.resources.IWorkspace workspace = JavaPlugin.getWorkspace();
		methodPage = new AddEjbMethodWizardPage("EJB Business Methods Page");
		addPage(methodPage);
	}

	public void init(IWorkbench workbench, IStructuredSelection selection)
	{
		this.workbench = workbench;
		this.selection = selection;
		try
		{
			if(selection != null && selection.getFirstElement() != null && (selection.getFirstElement() instanceof IType))
			{
				theClass = (IType)selection.getFirstElement();
				DOMFactory jdom = new DOMFactory();
				theCompUnit = jdom.createCompilationUnit(theClass.getCompilationUnit().getSource(), theClass.getCompilationUnit().getElementName());
				theType = jdom.createType(theClass.getSource());
				theType = (IDOMType)theCompUnit.getChild(theType.getName());
			}
		}
		catch(Exception e)
		{
			JonasLauncherPlugin.log(e);
		}
	}

	public void init(IWorkbench workbench, IType ejb)
	{
		this.workbench = workbench;
		theClass = ejb;
		try
		{
			DOMFactory jdom = new DOMFactory();
			theCompUnit = jdom.createCompilationUnit(theClass.getCompilationUnit().getSource(), theClass.getCompilationUnit().getElementName());
			theType = jdom.createType(theClass.getSource());
			theType = (IDOMType)theCompUnit.getChild(theType.getName());
		}
		catch(Exception e)
		{
			JonasLauncherPlugin.log(e);
		}
	}

	private AddEjbMethodWizardPage methodPage;
	private IStructuredSelection selection;
	private IWorkbench workbench;
	private IType theClass;
	private IDOMType theType;
	private IDOMCompilationUnit theCompUnit;
	private String integerTypes[] = {
		"byte", "char", "int", "long", "short"
	};
	private String doubleTypes[] = {
		"double", "float"
	};
}
